
struct Config
{
  enum {
    MaxKeyLength = 256,
    MaxLineLength = MAX_LINE_LENGTH,
    MaxTokenLength = MAX_LINE_LENGTH
  };

  const char *file;

	char key[MaxKeyLength];
	int keylen;

//	char one[MaxTokenLength];
//  ,two[MaxTokenLength],
//		three[MaxTokenLength],four[MaxTokenLength];
//	char *tokens[4];
	char line[MaxLineLength];
};

class ConfigState
{
public:
	int keylen;
	Config *config;

	ConfigState(Config *c,const char *key,int len) : config(c),keylen(len)
		{ if (config) { lstrcpy(config->key+config->keylen,key); config->keylen+=keylen; } }
	~ConfigState()
		{ if (config) { config->keylen-=keylen; config->key[config->keylen]=0; } }
};

struct ConfigItem;

typedef const char * (*GenericConfigParser)(Config *c, const char *s, void *base, const ConfigItem *i,bool bInit);
typedef bool (*GenericConfigFreer)(void *base, const ConfigItem *i);

struct ConfigItemType
{
  enum {
    Simple, Compound, Bracketed
  } Type;
  GenericConfigParser Parser;
  GenericConfigFreer Freer;
};

inline const char *CallParser(const ConfigItem * const item, Config *cfg, const char *str, void *base, bool bInit)
{
  ASSERT_READABLE(item);
  ASSERT_READABLE(item->Type);
  ASSERT_EXECABLE(item->Type->Parser);
  return item->Type->Parser(cfg,str,base,item,bInit);
}

template<typename type>
inline const char *CallParser(Config *cfg, const char *str, type *base, bool bInit)
{
  ASSERT_READABLE(base);
  const ConfigItem * const item = type::ConfigItemPtr;
  return CallParser(item,cfg,str,base,bInit);
}

inline bool CallFreer(const ConfigItem * const item, void *base)
{
  ASSERT_READABLE(item);
  ASSERT_READABLE(item->Type);
  ASSERT_EXECABLE(item->Type->Freer);
  return item->Type->Freer(base,item);
}

template<typename type>
inline bool CallFreer(type *base)
{
  ASSERT_READABLE(base);
  const ConfigItem * const item = type::ConfigItemPtr;
  return CallFreer(item,base);
}
