<!-- This documentation is auto-generated from docgen.cpp -->

#include "settings.h"
#include "modtype.h"

#define BOXNAME #boxname

#define PARAM(name,type) <span class="param">&lt;<a href=STR(type)>name</a>&gt;</span>
#define OPARAM(name,type) <span class="oparam">[&lt;<a href=STR(type)>name</a>&gt;]</span>

#define BANG(n) <dt class="bang" id=STR(b_##n)>!##V(MODULE_NAME_SHORT)##n
#define BANGREF(n) !##V(MODULE_NAME_SHORT)##n
#define CONF(n) <dt class="config" id=STR(c_##n)>V(MODULE_NAME_SHORT)##n
#ifdef SINGLE_WINDOW
#define WBANG(n) BANG(n)
#define WCONF(n) <dt class="config" id=STR(w_##n)>V(MODULE_NAME_SHORT)##n
#else
#define WBANG(n) BANG(n) PARAM(box name,BOXNAME)
#define WCONF(n) <dt class="config" id=STR(w_##n)>PARAM(box name,BOXNAME)n
#endif

#define MAIL(n) STR(mailto:n)

<html>

<head>
<link rel="StyleSheet" href="module.css" type="text/css">
<title>MODULE_NAME_LONG MODULE_VERSION Documentation</title>
</head>
<body>
<h1>MODULE_NAME_LONG MODULE_VERSION</h1>
<p>
by <a href=MAIL(MODULE_AUTHOR_EMAIL)>MODULE_AUTHOR</a>
</p>

<p>General purpose template module.  This module will create any number of
skinned windows.  Any of these can have specific actions assigned to them,
can have their skin, position, size, alpha, etc changed without recycling.
You can also create and destroy windows while the module is running.
</p>

<p class="section">
<h3 class="l"><a name="toc">Contents</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<ul>
<li><a href="#config">Configuration</a>
#ifndef NO_SKIN
<li><a href="#skin">Skin Config</a>
#endif
#ifndef NO_SCRIPT_ACTIONS
<li><a href="#actions">Script Actions</a>
#endif
<li><a href="#bangs">Bang Commands</a>
<li><a href="#changes">Change Log</a>
</ul>
</p>

<p class="section">
<h3 class="l"><a name="config">Config Options</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<dl>
#ifdef SINGLE_WINDOW
CONF(InBox) OPARAM(inbox,bool)
<dd>Tells the module that it will be loaded by lsBox, so it should not
create its main window on its own.
#endif
#ifndef SINGLE_WINDOW
<dt><a name="starline">*MODULE_NAME_SHORT</a> PARAM(name,#boxname) OPARAM(monitor,#mon) OPARAM(x,#pos) OPARAM(y,#pos) OPARAM(width,#size) OPARAM(height,#size) OPARAM(#flags,#flags)
<dd>Creates a window, giving its initial position, size, and flags:
<pre>
T <a href="#w_OnTop">OnTop</a>
L <a href="#w_TrueAlpha">TrueAlpha</a>
H <a href="#w_Hidden">Hidden</a>
</pre>
Any numbers in the #flags will be interpreted as Group.
#endif
WCONF(OnMonitor) PARAM(monitor,#mon)
WCONF(X) PARAM(x,#pos)
WCONF(Y) PARAM(y,#pos)
<dd>Sets the initial position of the window.
#ifndef SINGLE_WINDOW
This will override the value given in the <a href="#starline">*MODULE_NAME_SHORT</a> line.
#endif
WCONF(Width) PARAM(width,#size)
WCONF(Height) PARAM(height,#size)
<dd>Sets the initialsize of the window.
#ifndef SINGLE_WINDOW
This will override the value given in the <a href="#starline">*MODULE_NAME_SHORT</a> line.
#endif
WCONF(Alpha) PARAM(amount,#alpha)
<dd>Sets fake or true alpha amount.
WCONF(TrueAlpha) OPARAM(bool,#bool)
<dd>Creates the window as a "layered" window to allow true "win2k" transparency.
This is ignored if not supported by the system.
WCONF(OnTop) OPARAM(ontop,#bool)
WCONF(Hidden) OPARAM(hidden,#bool)
<dd>Sets the initial z-position and visibility of the window.
#ifndef SINGLE_WINDOW
These override any flags given on the <a href="#starline">*MODULE_NAME_SHORT</a> line.
WCONF(Group) PARAM(group,#int)
<dd>Sets the group number for this window.  Group 0 means no group.
#endif
</dl>


#ifndef NO_SKIN
<p class="section">
<h3 class="l"><a name="skin">Skin Config</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<dl>
WCONF(Bitmap) PARAM(bitmap,#bitmap)
<dd>Sets the initial skin bitmap.
WCONF(Edge) PARAM(edge,#int)
WCONF(Edge) PARAM(left,#int) PARAM(top,#int) PARAM(right,#int) PARAM(bottom,#int)
<dd>Sets the edge of the bitmap that is not stretched or tiled.
WCONF(EdgeLeft) PARAM(edge,#int)
WCONF(EdgeTop) PARAM(edge,#int)
WCONF(EdgeRight) PARAM(edge,#int)
WCONF(EdgeBottom) PARAM(edge,#int)
<dd>Sets the edge for a specific side, useful to have one edge different from the rest.
WCONF(Tile) OPARAM(tile,#bool)
<dd>Sets whether the center of the bitmap is stretched or tiled.
WCONF(Color) OPARAM(style,#enum) OPARAM(face color,#color) OPARAM(highlight color,#color) OPARAM(shadow color,#color) OPARAM(highlight 2,#color) OPARAM(shadow 2,#color)
WCONF(ColorStyle) PARAM(style,#enum)
WCONF(ColorFace) PARAM(face color,#color)
WCONF(ColorLight) PARAM(highlight color,#color)
WCONF(ColorDark) PARAM(shadow color,#color)
WCONF(ColorBrLight) PARAM(highlight 2,#color)
WCONF(ColorDkDark) PARAM(shadow 2,#color)
<dd>Sets the colors to paint with if no bitmap is assigned.  The light color is used to draw
the top and left borders, the dark to draw the right and bottom borders.<br><br>
The style param can be any of: flat, raised, sunken, ridged, groove, raisedbutton, or sunkenbutton.
The second highlight and shadow are only used for the button style.<br><br>
Default values will draw the box like a regular system button.
</dl>
#endif

#ifndef NO_SCRIPT_ACTIONS
<p class="section">
<h3 class="l"><a name="actions">Script Actions</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<dl>
CONF(OnInit) PARAM(action,#cmd)
CONF(OnQuit) PARAM(action,#cmd)
<dd>Actions to perform when the module finishes initialization or begins shutting
down.  These actions can contain variables to replace.
#ifndef SINGLE_WINDOW
CONF(OnCreate) PARAM(action,#cmd)
CONF(OnDestroy) PARAM(action,#cmd)
<dd>Global action when any window is created or destroyed, any window-specific action
will override this.
CONF(OnMouseOver) PARAM(action,#cmd)
CONF(OnMouseOut) PARAM(action,#cmd)
CONF(OnMouseMove) PARAM(action,#cmd)
<dd>Global action when the mouse enters, leaves, or moves over any window that
does not have a specific action.
CONF(OnHover) PARAM(action,#cmd)
CONF(OnUnhover) PARAM(action,#cmd)
<dd>Global action when the mouse hovers or stops hovering over any window that
does not have a specific action.
CONF(HoverTime) PARAM(msecs,#int)
<dd>Sets the module-wide delay for mouse hover, defaults to the system setting.
CONF(OnLButtonDown) PARAM(action,#cmd)
CONF(OnRButtonDown) PARAM(action,#cmd)
CONF(OnMButtonDown) PARAM(action,#cmd)
<dd>Global action when the left, right, or middle mouse button is pressed
in any window that does not have a specific action.
CONF(OnLButtonUp) PARAM(action,#cmd)
CONF(OnRButtonUp) PARAM(action,#cmd)
CONF(OnMButtonUp) PARAM(action,#cmd)
<dd>Global action when the left, right, or middle mouse button is released
in any window that does not have a specific action.
#endif /* SINGLE_WINDOW */
WCONF(OnCreate) PARAM(action,#cmd)
WCONF(OnDestroy) PARAM(action,#cmd)
<dd>Action to perform when the window is created or destroyed.
WCONF(OnMouseOver) PARAM(action,#cmd)
WCONF(OnMouseOut) PARAM(action,#cmd)
WCONF(OnMouseMove) PARAM(action,#cmd)
<dd>Action to perform when the mouse enters, leaves, or moves over the window.
WCONF(OnHover) PARAM(action,#cmd)
WCONF(OnUnhover) PARAM(action,#cmd)
<dd>Action to perform when the mouse hovers or stops hovering over the window.
WCONF(HoverTime) PARAM(msecs,#int)
<dd>Delay before the mouse is considered hovering.
WCONF(OnLButtonDown) PARAM(action,#cmd)
WCONF(OnRButtonDown) PARAM(action,#cmd)
WCONF(OnMButtonDown) PARAM(action,#cmd)
<dd>Action to perform when the left, right, or middle mouse button is pressed.
WCONF(OnLButtonUp) PARAM(action,#cmd)
WCONF(OnRButtonUp) PARAM(action,#cmd)
WCONF(OnMButtonUp) PARAM(action,#cmd)
<dd>Action to perform when the left, right, or middle mouse button is released.
</dl>
#endif /* NO_SCRIPT_ACTIONS */ 




<p class="section">
<h3 class="l"><a name="bangs">Bang Commands</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<dl>
WBANG(Move) OPARAM(monitor,#mon) OPARAM(x,#pos) OPARAM(y,#pos) OPARAM(width,#size) OPARAM(height,#size)
<dd>Changes the position and size of the window.

WBANG(Size) PARAM(width,#size) PARAM(height,#size)
<dd>Changes the size of the window.

WBANG(OnTop) OPARAM(state,#bool)
<dd>Sets or toggles whether the window floats above normal windows.

WBANG(Alpha) PARAM(amount,#amount)
<dd>Changes the alpha transparency amount.

WBANG(Show) OPARAM(state,#bool)
<dd>Shows or hides the window.

BANG(LoadBoxHook) ... PARAM(name=,#lsboxname) PARAM(box file,#file) PARAM(box HWND,#HWND)
<dd>Loads the window into an lsbox.

#ifndef NO_SCRIPT_ACTIONS
WBANG(Exec) PARAM(command,#cmd)
<dd>Executes a command, replacing variables in this window's context.

WBANG(Action) PARAM(action name,#action) OPARAM(command,#cmd)
<dd>Sets the action for a triggered event.

#endif
#ifndef NO_SKIN
WBANG(Bitmap) PARAM(bitmap,#bitmap)
<dd>Sets the bitmap to draw the window skin.

WBANG(Edge) PARAM(edge,#int)
WBANG(Edge) PARAM(left,#int) PARAM(top,#int) PARAM(right,#int) PARAM(bottom,#int)
<dd>Sets the edges of the skin, this area is not stretched or tiled.

WBANG(Tile) OPARAM(state,#bool)
<dd>Toggles whether the center part of the bitmap is stretched or tiled to cover the window.

<dd>Sets whether the center of the bitmap is stretched or tiled.

WBANG(Color) OPARAM(style,#enum) OPARAM(face color,#color) OPARAM(highlight color,#color) OPARAM(shadow color,#color) OPARAM(highlight 2,#color) OPARAM(shadow 2,#color)
<dd>Sets the colors to paint with if no bitmap is assigned.  The light color is used to draw
the top and left borders, the dark to draw the right and bottom borders.<br><br>
The style param can be any of: flat, raised, sunken, ridged, groove, raisedbutton, or sunkenbutton.
The second highlight and shadow are only used for the button style.

#endif
#ifndef SINGLE_WINDOW
BANG(Create) PARAM(name,#boxname) OPARAM(monitor,#mon) OPARAM(x,#pos) OPARAM(y,#pos) OPARAM(width,#size) OPARAM(height,#size) OPARAM(#flags,#flags)
<dd>Create a new window, same syntax as <a href="#starline">*MODULE_NAME_SHORT</a> lines.

WBANG(Destroy)
<dd>Destroy a window.
#endif
</dl>
</p>



<p class="section">
<h3 class="l"><a name="types">Argument Types</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<dl>

<dt><a name="int">Integer</a>
<dd>A simple decimal integer.

<dt><a name="pos">Position</a>, <a name="size">Size</a>
<dd>A position, usually relative to the screen.  This can be a simple integer, or it
can be a negative number for relative to the right/bottom edge.  If you add a C suffix,
it will be relative to the center, or an R for relative to the current or default value.
It can also be a percent, or a percent plus or minus some offset.<br><br>
Examples, given a range of 0-255:
<pre class="example">
    50     value =           50
    50c    value = 50%+50 = 157
    50r    value = 50 more than it was before
    50%    value = 50%    = 127 (rounded down)
    50%-25 value = 50%-25 = 102
   -50     value = 255-50 = 205
   -50c    value = 50%-50 =  77
   -50%    value = 50%    = 128 (rounded up)
</pre>
The difference between 50% and -50% is so you can create a box 5% wide that rests up
against the right side of the screen.  95% would be off by a few pixels due to rounding,
but -5% would put it exactly at the edge.<br><br>
You can force a postion off screen with things like 0%-12 and 100%+15.

<dt><a name="mon">Monitor</a>
<dd>The name of a monitor defined by <code>MonitorNames</code>.  A monitor name must
begin with a letter.  If no monitor is given, the primary is taken by default on startup.
The special name "all" is reserved and refers to the total combined desktop area.

<dt><a name="bool">Boolean</a>
<dd>A true/false setting.  Leaving this command out entirely will default to false,
specifying the command with no parameters sets it to true.  Other valid values are:
<code>true</code>, <code>false</code>, <code>on</code>, <code>off</code>,
<code>yes</code>, <code>no</code>, and <code>toggle</code>.

<dt><a name="color">Color</a>
<dd>A six to eight digit hex number specifying the red, green, and blue components and
optionally alpha.  (order is RRGGBBAA)  These colors are the same as for HTML/CSS.<br><br>
Other possibilities include a system color index preceded by a colon, or the special index
:-1 to use the face color.  Colors can also be scaled with a + or - value (in decimal):
<pre class="example">
                RED  GREEN  BLUE  ALPHA
  808080        128   128   128   255
  80808080      128   128   128   128
  808080+20     148   148   148   255
  80808080+20   148   148   148   128 (alpha does not scale)
  :13            56    88   137   255 (system "select" color)
  :13-20         36    68   117   255
  :13@80         56    88   137   128 (set alpha in hex)
  :-1+40          (face color + 40)
</pre>
Note that colors preceded by : will automatically be recalculated (including scaling)
when their base color changes, for example if you change the system colors.

<dt><a name="cmd">Command</a>
<dd>This can be any bang command or executable file, with or without parameters.  If
the filename contains spaces, you must put quotes around it.  If you want to execute
more than one action, either use a scripting module to bind them together into one
bang command, or use <code>!execute [command 1][command 2][etc]</code>.<br><br>
You may include <a href="#vars">^@vars^</a> anywhere in this and they will be
substituded automatically.

</dl>
</p>




<p class="section">
<h3 class="l"><a name="changes">Change Log</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<pre>
#include "changes.txt"
</pre>
</p>

<p class="section">
<h3 class="l"><a name="vars">^@variables^</a></h3><br><h4></h4><div class="hr"></div>
<br clear="left">
<!-- /* This needs to be written in line */ -->
<pre>
#include "atvars.txt"
</pre>
</p>

</body>
</html>