
// get an offset in bytes from the beginning of a structure to a specific member
#define MEMBER_OFFSET(type,member) reinterpret_cast<int>(&(reinterpret_cast<type *>(NULL)->member))
// return a pointer to that member, given an object and a type
#undef APPLY_OFFSET
#define APPLY_OFFSET(object,type,offset) reinterpret_cast<type *>(reinterpret_cast<char *>(object)+(offset)/sizeof(char))
/* these are like ::*, but I need to be able to ignore all types involved */ 

#define CONF_ROOT(type,p1,p2) { 0,0,0,false,&CIT_##type,(LPARAM)p1 ,(LPARAM)p2   },
#define REQCONF_ITEM(name,len,type,struc,var,p1,p2) { name,len,MEMBER_OFFSET(struc,var),false,&CIT_##type,(LPARAM)p1   ,(LPARAM)p2   },
#define OPTCONF_ITEM(name,len,type,struc,var,p1,p2) { name,len,MEMBER_OFFSET(struc,var),true ,&CIT_##type,(LPARAM)p1   ,(LPARAM)p2   },
#define CONF_FLAG(chr,name,len,struc,var)           { name,len,MEMBER_OFFSET(struc,var),false,&CIT_Bool  ,(LPARAM)false,(LPARAM)chr  },

#define DECL_CIT(type) extern ConfigItemType CIT_##type;


DECL_CIT(Compound       ) // Compound parser, param1 = sizeof child struct, param2 -> subitem list
DECL_CIT(CompoundFree   ) // Compound parser with cleanup, param1 = sizeof child struct, param2 -> subitem list
DECL_CIT(UnitCompound   ) // Compound parser, fails as a unit, param1 = sizeof child struct, param2 -> subitem list
DECL_CIT(Bool           ) // Boolean parser, param1 = default, param2 = flag char
DECL_CIT(Long           ) // Long int parser, param1 = default
DECL_CIT(Color          ) // Color parser, param1 = default, param2 = GetSysColor index or -1
DECL_CIT(StrToken       ) // String token parser, fails for numbers
DECL_CIT(Ordinate       ) // Position/Size element parser, param1 = default percent, param2 = default offset
DECL_CIT(SimpleOrd      ) // Simple coordinate-style element, param1 = default, param2 = max (min = 0)
DECL_CIT(Flags          ) // #flags parser, var is "group" int, param1 = default group, param2 -> flag list
DECL_CIT(Bitmap         ) // HBITMAP parser
DECL_CIT(ActionSet      ) // Script action set parser, param1 = count, param2 -> action name strings
DECL_CIT(Enum           ) // Parse an int from a string, param1 = default, param2 -> string list
